<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.2"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>ADCS-Hardware-in-the-Loop: utilities Namespace Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
  $(document).ready(function() { init_search(); });
/* @license-end */
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="TUDSaT_.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">ADCS-Hardware-in-the-Loop<span id="projectnumber">&#160;0.0</span>
   </div>
   <div id="projectbrief">This is a hardware in the Loop</div>
  </td>
    <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.svg"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.svg" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.2 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('namespaceutilities.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle"><div class="title">utilities Namespace Reference</div></div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a1897ac7578d69d15311f4cba8342520c"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#a1897ac7578d69d15311f4cba8342520c">apply_sensitivity</a> (float value, float sensitivity)</td></tr>
<tr class="separator:a1897ac7578d69d15311f4cba8342520c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af5c091829a3a71bf79e949fd01235fd7"><td class="memItemLeft" align="right" valign="top">np.ndarray&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#af5c091829a3a71bf79e949fd01235fd7">get_acceleration_frame_transformation</a> (np.ndarray position, np.ndarray orientation, np.ndarray angular_velocity, np.ndarray angular_acceleration, np.ndarray velocity=[0, 0, 0], np.ndarray acceleration=[0, 0, 0])</td></tr>
<tr class="separator:af5c091829a3a71bf79e949fd01235fd7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afbf40a3dbaf1965a9c7250b95ffbd2e0"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#afbf40a3dbaf1965a9c7250b95ffbd2e0">calc_angular_motion_parameters</a> (str database)</td></tr>
<tr class="separator:afbf40a3dbaf1965a9c7250b95ffbd2e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff9b20378f64c39dd630fc754c9a99dd"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#aff9b20378f64c39dd630fc754c9a99dd">get_cardan_angular_velocity_transformation</a> (float beta, float gamma, W)</td></tr>
<tr class="separator:aff9b20378f64c39dd630fc754c9a99dd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae49a75eb2a8f0d61907921ebf0c4e054"><td class="memItemLeft" align="right" valign="top">np.ndarray&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#ae49a75eb2a8f0d61907921ebf0c4e054">get_quaternion_angular_velocity_transformation_non_unit_quaternions</a> (np.ndarray orientation, np.ndarray angular_velocity, s=1)</td></tr>
<tr class="separator:ae49a75eb2a8f0d61907921ebf0c4e054"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a48338e52a1a2f2b8b15bc45c7984a32b"><td class="memItemLeft" align="right" valign="top">np.ndarray&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#a48338e52a1a2f2b8b15bc45c7984a32b">get_quaternion_angular_velocity_transformation</a> (np.ndarray orientation, np.ndarray angular_velocity)</td></tr>
<tr class="separator:a48338e52a1a2f2b8b15bc45c7984a32b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa3d972c6f97a6bbbec799cd277d45755"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#aa3d972c6f97a6bbbec799cd277d45755">get_attitude</a> (vector1, vector2)</td></tr>
<tr class="separator:aa3d972c6f97a6bbbec799cd277d45755"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aab4c606d28f0224b0e8a58ef97e7b499"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#aab4c606d28f0224b0e8a58ef97e7b499">ned2ecef</a> (lon, lat)</td></tr>
<tr class="separator:aab4c606d28f0224b0e8a58ef97e7b499"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a92dc8d3720a4410dfd4c0d28f27b4745"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#a92dc8d3720a4410dfd4c0d28f27b4745">create_table</a> (str database, str name, str columns)</td></tr>
<tr class="separator:a92dc8d3720a4410dfd4c0d28f27b4745"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abda7d2859edb6c561a49699a358da6fe"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#abda7d2859edb6c561a49699a358da6fe">write_line_into_database_table</a> (str database, str name, tuple columns_content)</td></tr>
<tr class="separator:abda7d2859edb6c561a49699a358da6fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a88011419202e59b8ba01ecd3125edbda"><td class="memItemLeft" align="right" valign="top">pd.core.frame.DataFrame&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#a88011419202e59b8ba01ecd3125edbda">get_last_line_from_database_table</a> (str database, str name, int rows=1)</td></tr>
<tr class="separator:a88011419202e59b8ba01ecd3125edbda"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2782391bb18559b954bd2acd657beae7"><td class="memItemLeft" align="right" valign="top">pd.core.frame.DataFrame&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#a2782391bb18559b954bd2acd657beae7">get_table_from_database</a> (str database, str name)</td></tr>
<tr class="separator:a2782391bb18559b954bd2acd657beae7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1e441a7e53345a5cd02b4c734cb893a1"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#a1e441a7e53345a5cd02b4c734cb893a1">TEME_to_geodetic</a> (x, y, z, t, convert_time=True)</td></tr>
<tr class="separator:a1e441a7e53345a5cd02b4c734cb893a1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae42be3cf13c77c092a13e1fe001c228e"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#ae42be3cf13c77c092a13e1fe001c228e">ECEF_to_TEME</a> (x, y, z, t, convert_time=True)</td></tr>
<tr class="separator:ae42be3cf13c77c092a13e1fe001c228e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acde4868c6a9a670183e1607419802af6"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#acde4868c6a9a670183e1607419802af6">julian_to_decimal</a> (time, convert_time=True)</td></tr>
<tr class="separator:acde4868c6a9a670183e1607419802af6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aacd283a8bae1f09d328bdf00f1f72aed"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#aacd283a8bae1f09d328bdf00f1f72aed">interpolate_two_rows</a> (str database, str name, float sim_time)</td></tr>
<tr class="separator:aacd283a8bae1f09d328bdf00f1f72aed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a49aa75cc06a188648294793e81ddc535"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#a49aa75cc06a188648294793e81ddc535">get_mean_motion</a> (float a)</td></tr>
<tr class="separator:a49aa75cc06a188648294793e81ddc535"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab2de0cd86d98eba1f88049830f8c8e8a"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#ab2de0cd86d98eba1f88049830f8c8e8a">change_sensor_parameter</a> (sensor, list parameter, list new_val, float sim_time=0)</td></tr>
<tr class="separator:ab2de0cd86d98eba1f88049830f8c8e8a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a086a460a9ebf58e8f7d57edf41d7cc26"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#a086a460a9ebf58e8f7d57edf41d7cc26">euler_to_quaternion</a> (euler)</td></tr>
<tr class="separator:a086a460a9ebf58e8f7d57edf41d7cc26"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a30dc58f9462f8270d7f9bb6ce246808a"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#a30dc58f9462f8270d7f9bb6ce246808a">quaternion_to_euler</a> (q)</td></tr>
<tr class="separator:a30dc58f9462f8270d7f9bb6ce246808a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc06c2041355fe4c7d16d48631271cc0"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#abc06c2041355fe4c7d16d48631271cc0">quatNorm</a> (q)</td></tr>
<tr class="separator:abc06c2041355fe4c7d16d48631271cc0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afe14dd9db04d82f220da8d3989cfecb9"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#afe14dd9db04d82f220da8d3989cfecb9">quaternion_to_dcm</a> (q)</td></tr>
<tr class="separator:afe14dd9db04d82f220da8d3989cfecb9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad55d91156b44ce5a5c8a66463ea40870"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceutilities.html#ad55d91156b44ce5a5c8a66463ea40870">interpolate_dataframe</a> (dataframe, sim_time)</td></tr>
<tr class="separator:ad55d91156b44ce5a5c8a66463ea40870"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Function Documentation</h2>
<a id="a1897ac7578d69d15311f4cba8342520c" name="a1897ac7578d69d15311f4cba8342520c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1897ac7578d69d15311f4cba8342520c">&#9670;&nbsp;</a></span>apply_sensitivity()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.apply_sensitivity </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>sensitivity</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Simulates the sensitivity of the sensor.

:param value: (double) sensor output without sensitivity
:param sensitivity: (double) sensitivity of the sensor
:return: (double) sensor output with sensitivity
</pre> 
</div>
</div>
<a id="afbf40a3dbaf1965a9c7250b95ffbd2e0" name="afbf40a3dbaf1965a9c7250b95ffbd2e0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afbf40a3dbaf1965a9c7250b95ffbd2e0">&#9670;&nbsp;</a></span>calc_angular_motion_parameters()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.calc_angular_motion_parameters </td>
          <td>(</td>
          <td class="paramtype">str&#160;</td>
          <td class="paramname"><em>database</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Converts the angular position of the last few time steps into an angular velocity and acceleration

    :param sim_time: (float) simulation time</pre> 
</div>
</div>
<a id="ab2de0cd86d98eba1f88049830f8c8e8a" name="ab2de0cd86d98eba1f88049830f8c8e8a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab2de0cd86d98eba1f88049830f8c8e8a">&#9670;&nbsp;</a></span>change_sensor_parameter()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.change_sensor_parameter </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>sensor</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">list&#160;</td>
          <td class="paramname"><em>parameter</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">list&#160;</td>
          <td class="paramname"><em>new_val</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float &#160;</td>
          <td class="paramname"><em>sim_time</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Method that adds change request to respective sensor's parameter table. This method is thought to be called
by the GUI.

:param sensor: (Sensor type) the sensor object whose parameter is supposed to be changed
:param parameter: (list of strings) the attribute names of the parameters that are supposed to be changed
:param new_val: (list of type(parameter)) the new values for the changed parameters (NO numpy arrays allowed, instead use
                    python list)
:param sim_time: (float) the simulation time the parameter change is conducted
</pre> 
</div>
</div>
<a id="a92dc8d3720a4410dfd4c0d28f27b4745" name="a92dc8d3720a4410dfd4c0d28f27b4745"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a92dc8d3720a4410dfd4c0d28f27b4745">&#9670;&nbsp;</a></span>create_table()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.create_table </td>
          <td>(</td>
          <td class="paramtype">str&#160;</td>
          <td class="paramname"><em>database</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">str&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">str&#160;</td>
          <td class="paramname"><em>columns</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment"> Create a new table in the database.

:param database: (str) name of the database
:param name: (str) name of the table
:param columns: (str) names of the columns separated by commas
</pre> 
</div>
</div>
<a id="ae42be3cf13c77c092a13e1fe001c228e" name="ae42be3cf13c77c092a13e1fe001c228e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae42be3cf13c77c092a13e1fe001c228e">&#9670;&nbsp;</a></span>ECEF_to_TEME()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.ECEF_to_TEME </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>z</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>convert_time</em> = <code>True</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">convert the coordinates given in an ECEF to the TEME frame at
the given time in julian days
(code from TUDSat code)
</pre> 
</div>
</div>
<a id="a086a460a9ebf58e8f7d57edf41d7cc26" name="a086a460a9ebf58e8f7d57edf41d7cc26"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a086a460a9ebf58e8f7d57edf41d7cc26">&#9670;&nbsp;</a></span>euler_to_quaternion()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.euler_to_quaternion </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>euler</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Convert euler angles to a quaternion with scalar first representation
</pre> 
</div>
</div>
<a id="af5c091829a3a71bf79e949fd01235fd7" name="af5c091829a3a71bf79e949fd01235fd7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af5c091829a3a71bf79e949fd01235fd7">&#9670;&nbsp;</a></span>get_acceleration_frame_transformation()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"> np.ndarray utilities.get_acceleration_frame_transformation </td>
          <td>(</td>
          <td class="paramtype">np.ndarray&#160;</td>
          <td class="paramname"><em>position</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">np.ndarray&#160;</td>
          <td class="paramname"><em>orientation</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">np.ndarray&#160;</td>
          <td class="paramname"><em>angular_velocity</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">np.ndarray&#160;</td>
          <td class="paramname"><em>angular_acceleration</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">np.ndarray &#160;</td>
          <td class="paramname"><em>velocity</em> = <code>[0,&#160;0,&#160;0]</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">np.ndarray &#160;</td>
          <td class="paramname"><em>acceleration</em> = <code>[0,&#160;0,&#160;0]</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Transforms the acceleration into the sensor frame.

Velocity and acceleration are differentiations of the position vector of the sensor. Velocity and acceleration of
the satellite aren't considered.
:param position: (numpy array, 1x3 x y z) position of the sensor in the satellite frame
:param orientation: (numpy array, 1x4 qi qj qk qr) quaternion that describes the rotation of the sensor in the
                                                                                                    satellite frame
:param angular_velocity: (numpy array, 1x3 omega_x omega_y omega_z) angular velocity of the satellite in the
                            satellite coordinate frame
:param angular_acceleration: (numpy array, 1x3 alpha_x alpha_y alpha_z) angular acceleration of the satellite in the
                            satellite coordinate frame
:param velocity: (numpy array, 1x3 v_x v_y v_z) velocity of the satellite in the satellite frame
:param acceleration: (numpy array, 1x3 a_x a_y a_z) acceleration of the satellite in the satellite frame
:return: (numpy array, 1x3 a_x a_y a_z) acceleration of the sensor in the sensor frame
</pre> 
</div>
</div>
<a id="aa3d972c6f97a6bbbec799cd277d45755" name="aa3d972c6f97a6bbbec799cd277d45755"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa3d972c6f97a6bbbec799cd277d45755">&#9670;&nbsp;</a></span>get_attitude()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.get_attitude </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>vector1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>vector2</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">returns the quaternion that rotates one vector into the other.
(modified code from TUDSat script)
Args:
    vector1 (numpy ndarray): first vector
    vector2 (numpy ndarray): second vector

Returns:
    quaternion (pyquaternion.Quaternion): A quaternion that represents a rotation from first to second vector
</pre> 
</div>
</div>
<a id="aff9b20378f64c39dd630fc754c9a99dd" name="aff9b20378f64c39dd630fc754c9a99dd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aff9b20378f64c39dd630fc754c9a99dd">&#9670;&nbsp;</a></span>get_cardan_angular_velocity_transformation()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.get_cardan_angular_velocity_transformation </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>beta</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>gamma</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>W</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Transforms the angular velocity of the satellite frame into the sensor frame by using euler coordinates.

:param beta: (double) rotation of y-axis of the sensor in euler coordinates
:param gamma: (double) rotation of z-axis of the sensor in euler coordinates
:param W: (numpy array, 1x3 Wx Wy Wz) angular velocity of the satellite in the satellite coordinate frame
:return: (numpy array, 1x3 Wx Wy Wz) vector of the angular velocity in the sensor frame
</pre> 
</div>
</div>
<a id="a88011419202e59b8ba01ecd3125edbda" name="a88011419202e59b8ba01ecd3125edbda"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a88011419202e59b8ba01ecd3125edbda">&#9670;&nbsp;</a></span>get_last_line_from_database_table()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"> pd.core.frame.DataFrame utilities.get_last_line_from_database_table </td>
          <td>(</td>
          <td class="paramtype">str&#160;</td>
          <td class="paramname"><em>database</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">str&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int &#160;</td>
          <td class="paramname"><em>rows</em> = <code>1</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment"> Read the last line of a table in the database.

:param database: (str) name of the database
:param name: (str) name of the table
:return: (pandas.core.frame.DataFrame)
:param rows: (int) number of lines that will be red in
</pre> 
</div>
</div>
<a id="a49aa75cc06a188648294793e81ddc535" name="a49aa75cc06a188648294793e81ddc535"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a49aa75cc06a188648294793e81ddc535">&#9670;&nbsp;</a></span>get_mean_motion()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.get_mean_motion </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>a</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Computes the mean motion in rad/minutes as required by the sgp4 propagator.

:param a: (float) semi-major axis of the orbit in km
:return: (float) the mean motion on the specified orbit in radians/minutes
</pre> 
</div>
</div>
<a id="a48338e52a1a2f2b8b15bc45c7984a32b" name="a48338e52a1a2f2b8b15bc45c7984a32b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a48338e52a1a2f2b8b15bc45c7984a32b">&#9670;&nbsp;</a></span>get_quaternion_angular_velocity_transformation()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"> np.ndarray utilities.get_quaternion_angular_velocity_transformation </td>
          <td>(</td>
          <td class="paramtype">np.ndarray&#160;</td>
          <td class="paramname"><em>orientation</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">np.ndarray&#160;</td>
          <td class="paramname"><em>angular_velocity</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Transforms the angular velocity of the satellite frame into the sensor frame by using quaternions.

:param orientation: (numpy array, 1x4 qi qj qk qr) quaternion that describes the rotation of the sensor in the
                    satellite frame
:param angular_velocity: (numpy array, 1x3 Wx Wy Wz) angular velocity of the satellite in the satellite coordinate
                        frame
:return: (numpy array, vector 3x1 Wx Wy Wz) vector of the angular velocity in the sensor frame
</pre> 
</div>
</div>
<a id="ae49a75eb2a8f0d61907921ebf0c4e054" name="ae49a75eb2a8f0d61907921ebf0c4e054"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae49a75eb2a8f0d61907921ebf0c4e054">&#9670;&nbsp;</a></span>get_quaternion_angular_velocity_transformation_non_unit_quaternions()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"> np.ndarray utilities.get_quaternion_angular_velocity_transformation_non_unit_quaternions </td>
          <td>(</td>
          <td class="paramtype">np.ndarray&#160;</td>
          <td class="paramname"><em>orientation</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">np.ndarray&#160;</td>
          <td class="paramname"><em>angular_velocity</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>s</em> = <code>1</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Transforms the angular velocity of the satellite frame into the sensor frame by using quaternions.

:param orientation: (numpy array, 1x4 qi qj qk qr) quaternion that describes the rotation of the sensor in the satellite frame
:param angular_velocity: (numpy array, 1x3 Wx Wy Wz) angular velocity of the satellite in the satellite coordinate frame
:param s: (double) s = ||q||**-2 if q is a unit quaternion then s = 1
:return: (numpy array, 1x3 Wx Wy Wz) vector of the angular velocity in the sensor frame
</pre> 
</div>
</div>
<a id="a2782391bb18559b954bd2acd657beae7" name="a2782391bb18559b954bd2acd657beae7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2782391bb18559b954bd2acd657beae7">&#9670;&nbsp;</a></span>get_table_from_database()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"> pd.core.frame.DataFrame utilities.get_table_from_database </td>
          <td>(</td>
          <td class="paramtype">str&#160;</td>
          <td class="paramname"><em>database</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">str&#160;</td>
          <td class="paramname"><em>name</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment"> Read the table from database.

:param database: (str) name of the database
:param name: (str) name of the table
:return: (pandas.core.frame.DataFrame)
</pre> 
</div>
</div>
<a id="ad55d91156b44ce5a5c8a66463ea40870" name="ad55d91156b44ce5a5c8a66463ea40870"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad55d91156b44ce5a5c8a66463ea40870">&#9670;&nbsp;</a></span>interpolate_dataframe()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.interpolate_dataframe </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>dataframe</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>sim_time</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="aacd283a8bae1f09d328bdf00f1f72aed" name="aacd283a8bae1f09d328bdf00f1f72aed"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aacd283a8bae1f09d328bdf00f1f72aed">&#9670;&nbsp;</a></span>interpolate_two_rows()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.interpolate_two_rows </td>
          <td>(</td>
          <td class="paramtype">str&#160;</td>
          <td class="paramname"><em>database</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">str&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>sim_time</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment"> Read the two lines of a table in the database that are closest to the sim_time.

:param database: (str) name of the database
:param name: (str) name of the table
:param sim_time: (float) the current simulation time
:return: (pandas.core.frame.DataFrame)
</pre> 
</div>
</div>
<a id="acde4868c6a9a670183e1607419802af6" name="acde4868c6a9a670183e1607419802af6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acde4868c6a9a670183e1607419802af6">&#9670;&nbsp;</a></span>julian_to_decimal()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.julian_to_decimal </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>time</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>convert_time</em> = <code>True</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">converts a julian day date to a decimal year
(code from TUDSat code)
</pre> 
</div>
</div>
<a id="aab4c606d28f0224b0e8a58ef97e7b499" name="aab4c606d28f0224b0e8a58ef97e7b499"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aab4c606d28f0224b0e8a58ef97e7b499">&#9670;&nbsp;</a></span>ned2ecef()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.ned2ecef </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>lon</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>lat</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Returns quaternion that transforms local north, east, down vector into ECEF vector. (Source:
https://gssc.esa.int/navipedia/index.php/Transformations_between_ECEF_and_ENU_coordinates
https://onlinelibrary.wiley.com/doi/pdf/10.1002/9780470099728.app3

:param lon: (float or list of floats) geodetic longitude in deg
:param lat: (float or list of floats) geodetic latitude in deg
:return: (scipy.Rotation) a rotation that represents the transformation from the NED to ECEF system
</pre> 
</div>
</div>
<a id="afe14dd9db04d82f220da8d3989cfecb9" name="afe14dd9db04d82f220da8d3989cfecb9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afe14dd9db04d82f220da8d3989cfecb9">&#9670;&nbsp;</a></span>quaternion_to_dcm()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.quaternion_to_dcm </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>q</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a30dc58f9462f8270d7f9bb6ce246808a" name="a30dc58f9462f8270d7f9bb6ce246808a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a30dc58f9462f8270d7f9bb6ce246808a">&#9670;&nbsp;</a></span>quaternion_to_euler()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.quaternion_to_euler </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>q</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="abc06c2041355fe4c7d16d48631271cc0" name="abc06c2041355fe4c7d16d48631271cc0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abc06c2041355fe4c7d16d48631271cc0">&#9670;&nbsp;</a></span>quatNorm()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.quatNorm </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>q</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a1e441a7e53345a5cd02b4c734cb893a1" name="a1e441a7e53345a5cd02b4c734cb893a1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1e441a7e53345a5cd02b4c734cb893a1">&#9670;&nbsp;</a></span>TEME_to_geodetic()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.TEME_to_geodetic </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>z</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>convert_time</em> = <code>True</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">convert coordinates(km) given in TEME frame and a time(julian day)
to latitude(deg), longitude(deg) and height(km)
(code from TUDSat code)
</pre> 
</div>
</div>
<a id="abda7d2859edb6c561a49699a358da6fe" name="abda7d2859edb6c561a49699a358da6fe"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abda7d2859edb6c561a49699a358da6fe">&#9670;&nbsp;</a></span>write_line_into_database_table()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def utilities.write_line_into_database_table </td>
          <td>(</td>
          <td class="paramtype">str&#160;</td>
          <td class="paramname"><em>database</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">str&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">tuple&#160;</td>
          <td class="paramname"><em>columns_content</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment"> Extends database table with one new line.

:param database: (str) name of the database
:param name: (str) name of the table
:param columns_content: (tuple) content that will be written in the table
</pre> 
</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceutilities.html">utilities</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.2 </li>
  </ul>
</div>
</body>
</html>
